# Location _search

`POST /Location/_search`

This resource contains information about a place where healthcare services are provided. This could be where services are rendered to a patient or even where medical supplies are stored.

You can review or retrieve location details.

> **Supported fields and schema examples**
>
> We support any valid FHIR field. However, we only display fields we’ve defined in our schema, which are usually based on what’s included in the U.S. Core profile. We recommend relying on U.S. Core requirements. 
>
> Our schema examples show the shape and possibility of each FHIR resource; they aren’t code for real-time API calls. We don’t currently recommend copying and pasting these schema examples for your API calls. [Consider reviewing FHIR API actions](/fhir-api-actions) for realistic examples for particular use cases.

### \_search

Query for location records of healthcare services or supplies.

> **Flexible FHIR queries, different query parameters**
>
> FHIR queries are a flexible option with parameters to refine your search. The response returns a bundle of resources, known as a `searchset` bundle type. [Learn about bundles and bundle types](https://docs.redoxengine.com/permalink/23Q1Oku3NdxxvwYnQGJVrg) in our FHIR glossary.
>
> We add a `required` label only to query parameters _a FHIR server requires if you query it directly_. Remember that Redox <u>**data on demand**</u> isn’t a FHIR server, and your connection may not be either.
>
> _Query parameters vary between sites._ Work with your connection to find out which query parameters they require for a successful search.

## Request body

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `identifier` | Array of string | No | One or more external identifiers for the location |
| `name` | Array of string | No | A portion of the location's name or alias. |
| `address` | Array of string | No | A (part of the) address of the location |
| `address-city` | Array of string | No | A city specified in an address |
| `address-state` | Array of string | No | A state specified in an address |
| `address-postalcode` | Array of string | No | A postal code specified in an address |
| `type` | Array of string | No | A code for the type of location |
| `physical-type` | Array of string | No | The location's physical form |
| `name-physical-type` | Array of string | No | Specify both name and physical-type at once. This is a Redox-specific parameter. |
| `partof` | Array of string | No | A location of which this location is a part |
| `partof.identifier` | Array of string | No | One or more external identifiers for the location |

## Request example

_Generated from the schema: the values are placeholders, not a real payload._

```bash
curl 'https://api.redoxengine.com/fhir/R4/{destinationSlug}/{environmentFlag}/Location/_search' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'identifier=string' \
--data-urlencode 'name=string' \
--data-urlencode 'address=string' \
--data-urlencode 'address-city=string' \
--data-urlencode 'address-state=string' \
--data-urlencode 'address-postalcode=string' \
--data-urlencode 'type=string' \
--data-urlencode 'physical-type=string' \
--data-urlencode 'name-physical-type=string' \
--data-urlencode 'partof=string' \
--data-urlencode 'partof.identifier=string'
```

## Responses

### 200

Search results (Bundle)

Response to a Location search operation

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: Bundle |
| `type` | string | Yes | Identifies this bundle as a response to a search. Value: searchset |
| `total` | number | Yes | The total number of matches |
| `entry` | Array of Location or Other | No | A resource matching the search criteria or related to a matching resource |
| `entry[] (Location).resource` | object | Yes | A physical place where services are provided |
| `entry[] (Location).resource.resourceType` | string | Yes | Identifies the type of the resource. Value: Location |
| `entry[] (Location).resource.name` | string | No | Name of the location as used by humans. Does not need to be unique. |
| `entry[] (Location).resource.type` | Array of object | No | Indicates the type of function performed at the location. |
| `entry[] (Location).resource.type[].text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Location).resource.telecom` | Array of object | No | The contact details of communication devices available at the location. This can include phone numbers, fax numbers, mobile numbers, email addresses and web sites. |
| `entry[] (Location).resource.telecom[].system` | string | No | Telecommunications form for contact point - what communications system is required to make use of the contact. Possible values: phone, fax, email, pager, url, sms, other |
| `entry[] (Location).resource.telecom[].value` | string | No | The actual contact point details, in a form that is meaningful to the designated communication system (i.e. phone number or email address). |
| `entry[] (Location).resource.telecom[].use` | string | No | Identifies the purpose for the contact point. Possible values: home, work, temp, old, mobile |
| `entry[] (Location).resource.address` | object | No | Physical location. |
| `entry[] (Location).resource.address.use` | string | No | The purpose of this address. Possible values: home, work, temp, old, billing |
| `entry[] (Location).resource.address.line` | Array of string | No | This component contains the house number, apartment number, street name, street direction,  P.O. Box number, delivery hints, and similar address information. |
| `entry[] (Location).resource.address.city` | string | No | The name of the city, town, suburb, village or other community or delivery center. |
| `entry[] (Location).resource.address.district` | string | No | The name of the administrative area (county). |
| `entry[] (Location).resource.address.state` | string | No | Sub-unit of a country with limited sovereignty in a federally organized country. A code may be used if codes are in common use (e.g. US 2 letter state codes). |
| `entry[] (Location).resource.address.postalCode` | string | No | A postal code designating a region defined by the postal service. |
| `entry[] (Location).resource.address.country` | string | No | Country - a nation as commonly understood or generally accepted. |
| `entry[] (Location).resource.physicalType` | object | No | Physical form of the location, e.g. building, room, vehicle, road. |
| `entry[] (Location).resource.physicalType.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Location).resource.physicalType.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Location).resource.physicalType.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Location).resource.physicalType.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Location).resource.partOf` | object | No | Another Location of which this Location is physically a part of. Must be a resource of type `Location`. |
| `entry[] (Location).resource.partOf.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Location).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Location).search.mode` | string | Yes | Identifies the Location as matching the search parameters. Value: match |
| `entry[] (Other).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Other).search.mode` | string | No | Why this entry is in the result set - whether it's included as a match or because of an _include requirement, or to convey information or warning information about the search process. Possible values: match, include, outcome - why this is in the result set |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "resourceType": "Bundle",
  "type": "searchset",
  "total": 0,
  "entry": [
    {
      "resource": {
        "resourceType": "Location",
        "id": "RedoxLocationExample",
        "name": "RHS Vista Oaks Clinic",
        "type": [
          {
            "coding": [
              {
                "code": "OF",
                "system": "http://terminology.hl7.org/CodeSystem/v3-RoleCode",
                "display": "Outpatient Facility"
              }
            ]
          }
        ],
        "physicalType": {
          "coding": [
            {
              "code": "bu",
              "system": "http://terminology.hl7.org/CodeSystem/location-physical-type",
              "display": "Building"
            }
          ]
        }
      },
      "search": {
        "mode": "match"
      }
    }
  ]
}
```

### 400

Request could not be processed or failed validation

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: OperationOutcome |
| `issue` | Array of object | Yes | A structured respresentation of the error that occurred |
| `issue[].severity` | string | Yes | Generally `error` or `fatal` Possible values: fatal, error, warning, information |
| `issue[].code` | string | Yes | A FHIR category code that describes the general type of issue. See http://hl7.org/fhir/ValueSet/issue-type for details |
| `issue[].id` | string | No | If the error occurs in the RedoxEngine, this corresponds to an Error record in the organization. |
| `issue[].details` | object | No | Additional details about the error. This may be a text description of the error or a system code that identifies the error. |
| `issue[].details.coding` | Array of object | No | A more granular FHIR code for the specific error. Typically from http://hl7.org/fhir/ValueSet/operation-outcome |
| `issue[].details.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `issue[].details.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `issue[].details.text` | string | No | A human-readable interpretation of the issue code |
| `issue[].diagnostics` | string | No | Additional diagnostic information about the issue. |

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "invalid",
      "details": {
        "coding": [
          {
            "code": "MSG_BAD_SYNTAX",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid content found in request body."
      }
    }
  ]
}
```

### 401

Authorization is required

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "unknown",
      "details": {
        "coding": [
          {
            "code": "MSG_AUTH_REQUIRED",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid authorization token"
      }
    }
  ]
}
```

### 500

Internal server error

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "processing",
      "details": {
        "coding": [
          {
            "code": "MSG_RESOURCE_ID_FAIL",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Unable to allocate resource id."
      }
    }
  ]
}
```

### 503

Service unavailable

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "transient",
      "details": {
        "text": "System is unable to process this message at this time."
      }
    }
  ]
}
```
